#ifndef _H8S_COMMON0_H_
#define _H8S_COMMON0_H_ 1

typedef unsigned char	BYTE;
typedef unsigned short	WORD;
typedef unsigned long	LONG;
typedef unsigned long long	ULL;
typedef   signed long long	SLL;
typedef   signed long	INT;
typedef   signed short	SHORT;
typedef   signed char	CHAR;

typedef unsigned char	u8;
typedef unsigned short	u16;
typedef unsigned long	u32;
typedef   signed long	int32;
typedef   signed short	int16;
typedef   signed char	int8;

// const    BYTE	*hex;
// volatile BYTE	chr2hex(BYTE);
// volatile BYTE	printNIBL(BYTE);
// volatile BYTE	printBYTE(BYTE);
// volatile WORD	printWORD(WORD);
// volatile LONG	printLONG(LONG);

static volatile union{ // ,Х,˥֥ʬѺΰ
	LONG l;
	struct{
		WORD w1;
		WORD w0;
	} w;
	struct{
		BYTE b3;
		BYTE b2;
		BYTE b1;
		BYTE b0;
	} b;
	struct{
		BYTE n7:4;
		BYTE n6:4;
		BYTE n5:4;
		BYTE n4:4;
		BYTE n3:4;
		BYTE n2:4;
		BYTE n1:4;
		BYTE n0:4;
	} n;
} i32;

#ifndef _H8S_MPU_
#warn "undefined _H8S_MPU_."
#else
# if _H8S_MPU_==2128
#	include "2128s.h"
#	define	LED_B	(P5.DR.BIT.B3)
#	define	LED_R	(P5.DR.BIT.B4)
# else
#  if _H8S_MPU_==2144
#	include "2144s.h"
#	define	LED_B	(P5.DR.BIT.B2)
#	define	LED_R	(P8.DR.BIT.B6)
#  else
#error "_H8S_MPU_ is invalid MPU model number."
#  endif
# endif
#endif

#include "SYS_default.inc"

#define NULL (void *)0

#endif
