  /*
*//* 
*//* H8S GPS monitor
*//*  09crt0.S: C language startup
*//*     Copyright (C) 2011 by HI.
*//*
*/

#include "H8S_common0.inc"

.section	.text

BEGIN	_crt0_start

#if 1

/* setup .data section */
	mov.l	#_data,er0
	mov.l	#_edata,er2
	sub.l	er0, er2
	mov.l	#___rodata_end,er1
	jsr 	@_sys_blkcpy

/* setup .bss section */
	mov.l	#_edata,er0
	mov.l	#_end,er2
	sub.l	er0, er2
	xor.l	er1, er1
	jsr 	@_sys_blkset

#else

/* setup .data section */
	mov.l	#___rodata_end,er0	; source
	mov.l	#_edata,er1	; end_point
	mov.l	#_data,er2	; dest.pointer
0:
	mov.w	@er0+,r3
	mov.w	r3,@er2
	inc.l	#2,er2
	cmp.l	er1,er2
	blo 	0b:8

/* setup .bss section */
	mov.l	#_edata,er0
	mov.l	#_end,er1
	sub.w	r2,r2
1:
	mov.w	r2,@er0
	inc.l	#2,er0
	cmp.l	er1,er0
	blo 	1b:8
#endif

/* call user routine */
	jsr	@_main

RETURN

	.end

